 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %                                                           %
    %                                                           %
    %         Mebrane complexes                                 %
    %                                                           %  
    %         y(1)   pMHC1   free                               %    
    %         y(2)   TCR|pMHC1                                  %
    %         y(3)   LCK|TCR|pMHC1                              %
    %         y(4)   LCKs|TCR|pMHC1                             %
    %         y(5)   LCKy|TCR|pMHC1                             %
    %         y(6)   LCKsy|TCR|pMHC1                            %
    %         y(7)   LCKy|pTCR|pMHC1                            %
    %         y(8)   LCKsy|pTCR|pMHC1                           %
    %         y(9)   LCKy|ppTCR|pMHC1                           %
    %         y(10)  LCKsy|ppTCR|pMHC1                          %
    %                                                           %
    %         y(11)   pMHC2  free                               %    
    %         y(12)   TCR|pMHC2                                 %
    %         y(13)   LCK|TCR|pMHC2                             %
    %         y(14)   LCKs|TCR|pMHC2                            %
    %         y(15)   LCKy|TCR|pMHC2                            %
    %         y(16)   LCKsy|TCR|pMHC2                           %
    %         y(17)   LCKy|pTCR|pMHC2                           %
    %         y(18)   LCKsy|pTCR|pMHC2                          %
    %         y(19)   LCKy|ppTCR|pMHC2                          %
    %         y(20)   LCKsy|ppTCR|pMHC2                         %
    %                                                           %
    %         y(21)  TCR free                                   %
    %                                                           % 
    %         y(22)       pSHP|TCR                              %
    %         y(23)       pSHP|TCR|pMHC1                        % 
    %         y(24)       pSHP|LCK|TCR|pMHC1 complex            %
    %         y(25)       pSHP|TCR|pMHC2                        %
    %         y(26)       pSHP|LCK|TCR|pMHC2                    %
    %                                                           %
    %         Cytosolic proteins                                %
    %                                                           %
    %         y(27)   LCK                                       %
    %         y(28)   SHP free                                  %
    %         y(29)   pSHP free                                 %
    %         y(30)   ZAP                                       %
    %         y(31)   ZAPp                                      %
    %         y(32)   MEK                                       %
    %         y(33)   pMEK                                      %
    %         y(34)   ppMEK                                     %
    %         y(35)   ERK                                       %
    %         y(36)   pERK                                      %
    %         y(37)   ppERK                                     %
    %                                                           %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 
    
 function dy=model(t,y,TR)

 parameters; %parametrization included in M-file 'parameters.m'
 
 %#########################################################################
 %######################################################################### 
 
 
 dy=zeros(NC,1);
 
  dy(1)=d1*(y(2)+y(3)+y(4)+y(5)+y(6)+y(7)+y(8)+y(9)+y(10)+y(23)+y(24))- b1*y(21)*y(1);  % pMHC1   free   
  dy(2)=b1*y(1)*y(21)+(s2+s3)*y(23)-(d1+lb*y(27)+ly1*y(29))*y(2);                       % TCR|pMHC1 
  dy(3)=lb*y(27)*y(2)+ls1*y(4)+(s2+s3)*y(24)-(d1+ly2+ls2*y(37)+ly1*y(29))*y(3);         % LCK|TCR|pMHC1                          
  dy(4)=ls2*y(37)*y(3)-(d1+ly2+ls1)*y(4);                                               % LCKs|TCR|pMHC1 
  dy(5)=ly2*y(3)+ls1*y(6)-(d1+tp+ls2*y(37)+ly1*y(29))*y(5);                             % LCKy|TCR|pMHC1    
  dy(6)=ly2*y(4)+ls2*y(37)*y(5)-(d1+tp+ls1)*y(6);                                       % LCKsy|TCR|pMHC1     
  dy(7)=tp*y(5)+ls1*y(8)-(d1+tp+ls2*y(37)+ly1*y(29))*y(7);                              % LCKy|pTCR|pMHC1      
  dy(8)=tp*y(6)+ls2*y(37)*y(7)-(d1+tp+ls1)*y(8);                                        % LCKsy|pTCR|pMHC1     
  dy(9)=tp*y(7)+ls1*y(10)-(d1+ls2*y(37)+ly1*y(29))*y(9);                                % LCKy|ppTCR|pMHC1    
  dy(10)=tp*y(8)+ls2*y(37)*y(9)-(d1+ls1)*y(10);                                         % LCKsy|ppTCR|pMHC1 
 
  dy(11)=d2*(y(12)+y(13)+y(14)+y(15)+y(16)+y(17)+y(18)+y(19)+y(20)+y(25)+y(26))-b2*y(21)*y(11);    % pMHC2   free 
  dy(12)=b2*y(11)*y(21)+(s2+s3)*y(25)-(d2+lb*y(27)+ly1*y(29))*y(12);                        % TCR|pMHC2 
  dy(13)=lb*y(27)*y(12)+ls1*y(14)+(s2+s3)*y(26)-(d2+ly2+ls2*y(37)+ly1*y(29))*y(13);         % LCK|TCR|pMHC2                          
  dy(14)=ls2*y(37)*y(13)-(d2+ly2+ls1)*y(14);                                                % LCKs|TCR|pMHC2 
  dy(15)=ly2*y(13)+ls1*y(16)-(d2+tp+ls2*y(37)+ly1*y(29))*y(15);                             % LCKy|TCR|pMHC2    
  dy(16)=ly2*y(14)+ls2*y(37)*y(15)-(d2+tp+ls1)*y(16);                                       % LCKsy|TCR|pMHC2     
  dy(17)=tp*y(15)+ls1*y(18)-(d2+tp+ls2*y(37)+ly1*y(29))*y(17);                              % LCKy|pTCR|pMHC2      
  dy(18)=tp*y(16)+ls2*y(37)*y(17)-(d2+tp+ls1)*y(18);                                        % LCKsy|pTCR|pMHC2     
  dy(19)=tp*y(17)+ls1*y(20)-(d2+ls2*y(37)+ly1*y(29))*y(19);                                 % LCKy|ppTCR|pMHC2    
  dy(20)=tp*y(18)+ls2*y(37)*y(19)-(d2+ls1)*y(20);                                           % LCKsy|ppTCR|pMHC2
  
     dy(21)=d1*(y(2)+y(3)+y(4)+y(5)+y(6)+y(7)+y(8)+y(9)+y(10))+d2*(y(12)+y(13)+y(14)+y(15)+y(16)+y(17)+y(18)+y(19)+y(20))+(s2+s3)*y(22)-b1*y(1)*y(21)-b2*y(11)*y(21)-ly1*y(29)*y(21);  %TCR  free
     dy(22)=ly1*y(29)*y(21) + d1*(y(23)+y(24))+d2*(y(25)+y(26)) -(s2+s3)*y(22);         % pSHP|TCR
     dy(23)=ly1*y(29)*y(2) -(s2+s3+d1)*y(23);                                           % pSHP|TCR|pMHC1
     dy(24)=ly1*y(29)*(y(3)+y(5)+y(7)+y(9))-(s2+s3+d1)*y(24);                           % pSHP|LCK|TCR|pMHC1  
     dy(25)=ly1*y(29)*y(12) -(s2+s3+d2)*y(25);                                          % pSHP|TCR|pMHC2 
     dy(26)=ly1*y(29)*(y(13)+y(15)+y(17)+y(19))-(s2+s3+d2)*y(26);                       % pSHP|LCK|TCR|pMHC2 
     dy(27)=d1*(y(3)+y(4)+y(5)+y(6)+y(7)+y(8)+y(9)+y(10)+y(24))+d2*(y(13)+y(14)+y(15)+y(16)+y(17)+y(18)+y(19)+y(20)+y(26))-lb*(y(2)+y(12))*y(27);                                                      %LCK                                 
     dy(28)=s2*(y(29)+y(22)+y(23)+y(24)+y(25)+y(26)) - s1*(y(5)+y(7)+y(9))*y(28)- s1*(y(15)+y(17)+y(19))*y(28)-s0*y(28);                                                                               %SHP free 
     dy(29)=s1*(y(5)+y(7)+y(9))*y(28)+s1*(y(15)+y(17)+y(19))*y(28) + s3*(y(22)+y(23)+y(24)+y(25)+y(26))-ly1*(y(2)+y(3)+y(5)+y(7)+y(9)+y(12)+y(13)+y(15)+y(17)+y(19)+y(21))*y(29)-s2*y(29)+s0*y(28);    %pSHP free                                     
     
     dy(30)=z2*y(31) - z1*(y(9)+y(10)+y(19)+y(20))*y(30) - z0*y(30);          % ZAP  
     dy(31)=z1*(y(9)+y(10)+y(19)+y(20))*y(30)+ z0*y(30)-z2*y(31);              % pZAP 
     dy(32)=m2*y(33) - 2*m1*y(31)*y(32);                                       % MEK 
     dy(33)=2*m1*y(31)*y(32)+2*m2*y(34)-m2*y(33)-m1*y(31)*y(33);               % pMEK
     dy(34)=m1*y(31)*y(33)- 2*m2*y(34);                                        % ppMEK      
     dy(35)=e2*y(36) - 2*e1*y(34)*y(35);                                        % ERK
     dy(36)=2*e1*y(34)*y(35)+2*e2*y(37)-e2*y(36)-e1*y(34)*y(36);               % pERK
     dy(37)=e1*y(34)*y(36)- 2*e2*y(37);                                        % ppERK                                     
     
                                                                      